
/**
 * Klasse zur Anwendung des Heronverfahrens.
 * 
 * @author (c.albowski) 
 * @version (07-01-2006)
 */
public class Heron
{
	// Instanzvariable
	int anzahlSchritte;
	double argument,startwert;
	double[] alleWerte;

	/**
	 * Konstruktor fr Objekte der Klasse Heron
	 */
	public Heron()
	{
		// Instanzvariable initialisieren
		anzahlSchritte = 10;
		argument = 15;
		startwert = 3;
	}

	/**
	 * Erhoeht bzw. vermindert die Anzahl der Schritte, mit denen gerechnet werden soll.
	 */
	public void mehrSchritte(boolean ja) {
	    if (ja) anzahlSchritte++; else if (anzahlSchritte>1) anzahlSchritte--;
	}
	
	/**
	 * Setzt die Zahl, aus der die Wurzel berechnet werden soll.
	 */
	public void setzeWurzel(double argument) {
		if (argument>0) this.argument=argument;
	}
	
	/**
	 * zeigt die Zahl, aus der die Wurzel berechnet werden soll.
	 */
	public double zeigeWurzel() {
		return argument;
	}
	
	/**
	 * Setzt die Zahl, mit der gestartet werden soll.
	 */
	public void setzeStartwert(double startwert) {
		if (startwert>0) this.startwert=startwert;
	}
	
	/**
	 * zeigt die Zahl, mit der gestartet werden soll.
	 */
	public double zeigeStartwert() {
		return startwert;
	}
	
	/**
	 * berechnet den Naeherungswert
	 */
	public double[] berechne() {
	    int max=anzahlSchritte+1;
	    alleWerte = new double[max];
	    alleWerte[0]=startwert;
	    for (int i=0;i<anzahlSchritte;i++) {
	        alleWerte[i+1]=(argument/alleWerte[i]+alleWerte[i])/2;
	    }
	    return alleWerte;
	}
}
